package sun.nio.ch;

import java.io.IOException;
import java.io.FileDescriptor;

class SocketDispatcher extends NativeDispatcher
{
    SocketDispatcher() {
    }
    
    @Override
    int read(FileDescriptor fileDescriptor, long n, int n2) throws IOException {
        return read0(fileDescriptor, n, n2);
    }
    
    @Override
    long readv(FileDescriptor fileDescriptor, long n, int n2) throws IOException {
        return readv0(fileDescriptor, n, n2);
    }
    
    @Override
    int write(FileDescriptor fileDescriptor, long n, int n2) throws IOException {
        return write0(fileDescriptor, n, n2);
    }
    
    @Override
    long writev(FileDescriptor fileDescriptor, long n, int n2) throws IOException {
        return writev0(fileDescriptor, n, n2);
    }
    
    @Override
    void preClose(FileDescriptor fileDescriptor) throws IOException {
        preClose0(fileDescriptor);
    }
    
    @Override
    void close(FileDescriptor fileDescriptor) throws IOException {
        close0(fileDescriptor);
    }
    
    static native int read0(FileDescriptor p0, long p1, int p2) throws IOException;
    
    static native long readv0(FileDescriptor p0, long p1, int p2) throws IOException;
    
    static native int write0(FileDescriptor p0, long p1, int p2) throws IOException;
    
    static native long writev0(FileDescriptor p0, long p1, int p2) throws IOException;
    
    static native void preClose0(FileDescriptor p0) throws IOException;
    
    static native void close0(FileDescriptor p0) throws IOException;
    
    static {
        IOUtil.load();
    }
}
